swagger: '2.0'
info:
  description: Configuration for visualizer lbv server binding resource.
  version: 'v2'
  title: ns_visualizer_lb_bindings
host: 'adm.cloud.com'
schemes:
 - https
# tags are used for organizing operations
tags:
  - name: ns_visualizer_lb_bindings
    description: visualizer lbv server binding
consumes:
  - application/json
produces:
  - application/json
securityDefinitions:
  UserSecurity:
    type: basic
security:
  - UserSecurity: []
parameters:
  authParam:
      in: header
      name: Authorization
      type: string
      required: true
      description: Session Id for authentication.Should be mentioned in the format CwsAuth bearer=sessionIdValue
  cloudParam:
      in: header
      name: isCloud
      type: string
      required: true
      description: set the value to true in case of Cloud services, false for on-prem deployment
paths:
  /massvc/{customerid}/nitro/v2/config/ns_visualizer_lb_bindings:
    get:
      tags:
        - ns_visualizer_lb_bindings
      summary: GET all ns_visualizer_lb_bindings
      operationId: getall_ns_visualizer_lb_bindings
      description: Use this operation to get lbvserver
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - in: path
          name: customerid
          type: string
          required: true
          description: Customer Id of the user
        - in: header
          name: Authorization
          type: string
          required: true
          description: Session Id for authentication.Should be mentioned in the format CwsAuth bearer=sessionIdValue
        - in: header
          name: isCloud
          type: string
          required: true
          description: set the value to true in case of Cloud services, false for on-prem deployment
        - in: query
          name: filter
          type: string
          required: false
          description: "Use this query-parameter to get the filtered set of vm_device resources configured on the system. You can set a filter on any property of the resource.Example:  property-name1:property-value1 "
        - in: query
          name: pagesize
          type: integer
          required: false
          description: Use this query-parameter to get the ns_visualizer_lb_bindings resources in chunks.To be used along with pageno query parameter.
        - in: query
          name: pageno
          type: integer
          required: false
          description: Use this query-parameter to get the ns_visualizer_lb_bindings resources in chunks.To be used along with pagesize query parameter.
        - in: query
          name: count
          type: string
          required: false
          description: Use this query-parameter to get the count of ns_visualizer_lb_bindings resources.
          enum:
            - yes
      responses:
        200:
          description:  for ns_visualizer_lb_bindings
          schema: 
              $ref: '#/definitions/getns_visualizer_lb_bindingssResponse'
        400:
          description: Bad input parameter
          schema: 
              $ref: '#/definitions/Error'
        401:
          description: Failed Authentication
          schema: 
              $ref: '#/definitions/Error'
        403:
          description: Unauthorized
          schema: 
              $ref: '#/definitions/Error'
        404:
          description: Item not found
          schema: 
              $ref: '#/definitions/Error'
        409:
          description: Resource Conflict
          schema: 
              $ref: '#/definitions/Error'
        500:
          description: Server Error
          schema: 
              $ref: '#/definitions/Error'
        504:
          description: Gateway Timeout
          schema: 
              $ref: '#/definitions/Error'

definitions:
  getns_visualizer_lb_bindingsResponse:
    type: object
    required:
      - ns_visualizer_lb_bindings
    properties:
      ns_visualizer_lb_bindings:
        $ref: '#/definitions/ns_visualizer_lb_bindings'
    title: getns_visualizer_lb_bindingsResponse
    example:
      ns_visualizer_lb_bindings:
        lbvserver_auditsyslogpolicy_binding: "audit_binding_name"
        lbvserver_appfwpolicy_binding: "appflow_binding_name"
        lbvserver_rewritepolicy_binding: "rewrite_policy_binding_name"
        policy_type: "string_value"
        lbvserver_spilloverpolicy_binding: "spillover_binding_name"
        lbvserver_auditnslogpolicy_binding: "auditns_binding_name"
        lbvserver_transformpolicy_binding: "transform_binding_name"
        lbvserver_appqoepolicy_binding: "app_qo_policy_binding_name"
        lbvserver_filterpolicy_binding: "filter_policy_binding_name"
        lbvserver_csvserver_binding: "csv_lbv_binding_name"
        lbvserver_feopolicy_binding: "feo_policy_binding_name"
        lbvserver_appflowpolicy_binding: "appflow_policy_binding_name"
        ip_address: "1.1.1.1"
        lbvserver_authorizationpolicy_binding: "auth_policy_binding_name"
        lbvserver_capolicy_binding: "ca_policy_binding_name"
        name: "vserver_name"
        lbvserver_servicegroup_binding: "servicegroup_binding_name"
        lbvserver_cachepolicy_binding: "cache_policy_binding_name"
        port: "22"
        lbvserver_service_binding: "service_binding_name"
        lbvserver_responderpolicy_binding: "responder_policy_binding_name"
        type: "string_value"
        ipaddress: "1.1.1.1"
        lbvserver_tmtrafficpolicy_binding: "tmtraffic_policy_binding_name"
        lbvserver_cmppolicy_binding: "compression_binding_name"

  getns_visualizer_lb_bindingssResponse:
    type: object
    required:
      - ns_visualizer_lb_bindings
    properties:
      ns_visualizer_lb_bindings:
        type: array
        items:
          $ref: '#/definitions/ns_visualizer_lb_bindings'
    title: getns_visualizer_lb_bindingssResponse
    example:
      ns_visualizer_lb_bindings:
        lbvserver_auditsyslogpolicy_binding: "audit_binding_name"
        lbvserver_appfwpolicy_binding: "appflow_binding_name"
        lbvserver_rewritepolicy_binding: "rewrite_policy_binding_name"
        policy_type: "string_value"
        lbvserver_spilloverpolicy_binding: "spillover_binding_name"
        lbvserver_auditnslogpolicy_binding: "auditns_binding_name"
        lbvserver_transformpolicy_binding: "transform_binding_name"
        lbvserver_appqoepolicy_binding: "app_qo_policy_binding_name"
        lbvserver_filterpolicy_binding: "filter_policy_binding_name"
        lbvserver_csvserver_binding: "csv_lbv_binding_name"
        lbvserver_feopolicy_binding: "feo_policy_binding_name"
        lbvserver_appflowpolicy_binding: "appflow_policy_binding_name"
        ip_address: "1.1.1.1"
        lbvserver_authorizationpolicy_binding: "auth_policy_binding_name"
        lbvserver_capolicy_binding: "ca_policy_binding_name"
        name: "vserver_name"
        lbvserver_servicegroup_binding: "servicegroup_binding_name"
        lbvserver_cachepolicy_binding: "cache_policy_binding_name"
        port: "22"
        lbvserver_service_binding: "service_binding_name"
        lbvserver_responderpolicy_binding: "responder_policy_binding_name"
        type: "string_value"
        ipaddress: "1.1.1.1"
        lbvserver_tmtrafficpolicy_binding: "tmtraffic_policy_binding_name"
        lbvserver_cmppolicy_binding: "compression_binding_name"

  ns_visualizer_lb_bindings_readwrite:
    type: object
    properties:
      ip_address:
        description: "IP Address"
        type: string
        format: ipaddress
        minLength: 1
        maxLength: 64
      ipaddress:
        description: "IP Address of  virtual server"
        type: string
        format: ipaddress

  ns_visualizer_lb_bindings:
    allOf:
      -
        properties:
          name:
            description: Name of lbvserver
            type: string
            format: string
          lbvserver_auditsyslogpolicy_binding:
             description: "Audit syslog policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_appfwpolicy_binding:
             description: "App Flow policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_rewritepolicy_binding:
             description: "Rewrite policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          policy_type:
             description: "Policy Type"
             type: string
             format: string
          lbvserver_spilloverpolicy_binding:
             description: "Spill Over policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_auditnslogpolicy_binding:
             description: " Audit ns policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_transformpolicy_binding:
             description: "Transform policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_appqoepolicy_binding:
             description: "app qo policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_filterpolicy_binding:
             description: "Filter policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_csvserver_binding:
             description: "CSV Server binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_feopolicy_binding:
             description: "Feo policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_appflowpolicy_binding:
             description: "App Flow policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_authorizationpolicy_binding:
             description: "Authorization policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_capolicy_binding:
             description: "CA policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_servicegroup_binding:
             description: "Service group binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_cachepolicy_binding:
             description: "Cache policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          port:
             description: "Port number for the virtual server"
             type: string
             format: string
          lbvserver_service_binding:
             description: "Service binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_responderpolicy_binding:
             description: "Responder policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          type:
             description: "type"
             type: string
             format: string
          lbvserver_tmtrafficpolicy_binding:
             description: "TM Traffic policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
          lbvserver_cmppolicy_binding:
             description: "Compression policy binding of Lbvserver"
             type: array
             items:
               type: string
               format: string
      - $ref: '#/definitions/ns_visualizer_lb_bindings_readwrite'

  Error:
    properties:
      errorcode:
        type: number
        format: int32
        example: 1001
      errormessage:
        type: string
        format: string
        example: "id cannot be found"
